#!/usr/bin/perl

# BLACK DIAMOND on Web
#
# Copyright 2005 ONODA Production 
#
# $Id: bd.pl,v 1.3 2005/02/06 03:31:20 onoda Exp $

use lib qw( ./lib );
use lib qw( ./extlib );

use CGI;
use HTML::Template;
use File::Basename;

use CGI::Session qw/-ip-match/;
use CGI::Session::Sweeper;


my $cgi = new CGI;

CGI::Session->name("BDSESSION_ID");
my $session = new CGI::Session("driver:File", $cgi, {Directory=>'./session'});


# ڤΥåκߤ
my $sweeper	= CGI::Session::Sweeper->new( "driver:File", { Directory => './session' } );
$sweeper->sweep;


# åͭ¤12֤ȤƤ
$session->expire("+12h");

#åID򥯥åꤷޤåID$session->id()ˤƼǤޤ
my $cookie = $cgi->cookie(
-name => 'BDSESSION_ID',
-value => $session->id(),
-expires => '+1h',
-path => $BD::gCgiPath . '/',
);

my $session_id = $session->id();

my $bd;
my $auth;
my $loginCount = 0;
my $firstStart = undef;


# 
# ɤPOSTǡʤξٹ
# ٤ƥʾϤifΤ򥳥ȥȤ
# 
if($ENV{REQUEST_METHOD} eq "POST") {
	$session->save_param($cgi);
	$session->close();
	# Ф㤦
print $cgi->header(
-cookie => $cookie,
-location => $BD::gScriptURL
);
exit;
} else {
	if(!$cgi->param("md")){
		$session->load_param($cgi);

		# $cgi¦˽ä顢åäƤΤϼΤƤ
		$session->param("md",'');
		$session->param("pass",'');
		$session->param("pass2",'');
		$session->param("selgame",'');
		$session->param("cmd",'');
		$session->param("cmd2",'');

	}
}

require 'bdlang.pl';
require 'bdconfig.pl';
require 'bdconfdef.pl';

use BD;
use bdUtil;
use bdAuth;
use bdConst;

print $cgi->header(
-type => 'text/html',
-charset => 'EUC-JP',
-cookie => $cookie
);


$bd = BD::instance;
$auth = new bdAuth($bd);

bdExpr::init();


if($cgi->param){
	if($cgi->param('md') eq 'login'){				# 
		my $user = $cgi->param('user');
		my $pass = $cgi->param('pass');
		my $err = $auth->login($user, $pass);


		$session->clear();

		# 򤷤̾
		$bd->{gameName} = $cgi->param("selgame");
		$bd->{gameTitle} = $BD::gGameTitleList{$bd->{gameName}};

		$bd->setupGameName();

		$session->param("inputUser",$user);

		if($err){
			# ǧڼԡ
			&loginError($err);
		}
		$firstStart = 1;
	}elsif($cgi->param('md') eq 'useraddform'){		# 桼Ͽե
		&userAddForm;
	}elsif($cgi->param('md') eq 'useradd'){			# 桼Ͽ¹
		&userAddExec();
	}elsif($cgi->param('md') eq 'logout'){			# 
		if($BD::gNoLogin == 0){
			if($session->param("bd_session") == 1){
				$bd->load_from_session($session);
			}
			$auth->logout();
			$session->param("bd_session",0);
			$bd->{backlog}->clear();
			$bd->{gameName} = undef;
		}
	}
}


# å󤫤Ƽ
if($session->param && ($session->param("bd_session") == 1)){
	$bd->load_from_session($session);
} else {
	# 
}
# ̾ꤵƤʤäꤹ
$bd->setupGameName();


if(!$auth->is_login()){		# 󤷤Ƥʤ
	# ̵⡼ɡ
	if($BD::gNoLogin == 1){
		my $err = $auth->login('guest','guest');
		
		if($err){
			print "ʤǧڥ顼 $err <br>";
		}

		$session->clear();

		# 򤷤̾
		$bd->{gameName} = $cgi->param("selgame");
		$bd->{gameTitle} = $BD::gGameTitleList{$bd->{gameName}};

		$bd->setupGameName();

		$session->param("inputUser",$user);

		$firstStart = 1;
	} else {
		&requireLogin();
	}
}

$bd->{errorStr} = '';

if($auth->is_login()){
	if($cgi->param('md') eq 'backlog'){			# Хåɽ
		&dispBacklog;
		# exit
	}
	if($cgi->param('md') eq 'keyword'){			# ɽ
		&dispKeywords;
		# exit
	}
	if($cgi->param('md') eq 'bgm'){				# BGM
		&dispBgm;
		# exit
	}



	# ι
	$loginCount = $auth->updateLoginList($bd->{loginUser});
	if($loginCount < 0){
		# Ȥ줿(Ĺ֤)Τǥ
		$auth->logout();
		$session->param("bd_session",0);
		&requireLogin();
	} else {
		if(!$bd->currentScene){
			# ưƼԤ
			$bd->load_script({'SymbolTable' => 1, 'ItemInit' => 1, 'SystemInit' => 1});
			$bd->set_currentScene( $bd->startScene );
		} else {
			# ߤʤΤǥܥơ֥ιۤΤ
			$bd->load_script({'SymbolTable' => 1});
		}

		# ꥷΥޥɥơ֥(ܥơ֥빽ۤߤǤɬפ)
		$bd->load_scene($bd->currentScene);

		if($bd->{gameMode} == bdConst::MODE_GAMEEND){
			# ཪλˤĤʤ
		} elsif($cgi->param('md') eq 'input'){
			# INPUT or YESNO

			my $cmd = $cgi->param('cmd');
			my $noexec = 0;
			if($bd->{gameMode} == bdConst::MODE_INPUTWAIT){
				# INPUT̿
				if($bd->return_input( $cmd )){
					$noexec = 1;
				}
			} else {
				my $cmd2 = $cgi->param('cmd2');
				# YESNO̿
				if($cmd){
					$cmd = 'yes';
				} else {
					$cmd = 'no';
				}
				$bd->return_yesno( $cmd );
			}

			if($noexec == 0){
				$bd->{gameMode} = bdConst::MODE_STOP;
				$bd->{outputStr} = '';
				$bd->script_exec();
			}
		} elsif($cgi->param('md') eq 'keywait'){
			# ԤʤΤǼ˿ʤ
			$bd->{gameMode} = bdConst::MODE_STOP;
			$bd->{outputStr} = '';
			$bd->script_exec();
		} elsif( ($cgi->param('md') eq 'command')){		# $cgi->param('cmd') ||
			# 桼Ϥä
			my $cmd = $cgi->param('cmd');
			if($cmd){
				my $ofs = $bd->search_command($cmd);

				$bd->{backlog}->add("<b>&gt; ".bdUtil::sanitize($cmd)."</b>");		# äȵɤɲ
		
				if($ofs){
					$bd->set_script_current( $ofs );
					$bd->{outputStr} = '';
					$bd->script_exec();
				}
			} else {
				# Ϥ̵äΤǲȿʤ(NOMATCHˤ)
				$bd->{outputStr} = '';
			}
		} elsif($firstStart){
			# ¹(ȥƬ¹)
			$bd->{gameMode} = bdConst::MODE_STOP;
			$bd->exec_goto($bd->currentScene);
			$bd->{outputStr} = '';
			$bd->script_exec();
		}
	}

}


# ɽ
my $tmpl =  HTML::Template->new(filename => "$BD::gTemplatesPath/game.tmpl");
setTemplateParams( $tmpl ,{ GAME=>1, SCRIPTURL=>1, GAMETITLE=>1 });

$bd->save_to_session($session);


# å󥯥
undef($session);





if( $bd->{gameMode} == bdConst::MODE_GAMEEND){
	# ཪλʤΤʥ
}elsif( $bd->{gameMode} == bdConst::MODE_INPUTWAIT2){
	# YES/NO
	$tmpl->param(MD_YESNO => 1);
}elsif( $bd->{gameMode} == bdConst::MODE_INPUTWAIT){
	# Ϥ¥
	$tmpl->param(MD_INPUT => 1);
} elsif( $bd->{gameMode} == bdConst::MODE_KEYWAIT){
	# Ԥ
	$tmpl->param(MD_KEYWAIT => 1);
} else {
	# ̾
	$tmpl->param(MD_NORMAL => 1);
}

print $tmpl->output;

exit;


# ƥץ졼ȥѥ᡼
sub setTemplateParams {
	my $tmpl = shift;
	my $mode = shift;

	$tmpl->param(BDCOPYRIGHT => $BD::gCopyrightTag);

	$tmpl->param(STATIC_URI => $BD::gStaticURI);

	# BGM
	if(${$mode}{BGM}){
		$tmpl->param(BGMFILE => $bd->{bgmFile} );
		$tmpl->param(BGM_LOOP => $bd->{bgmLoop} );
	}


	# SCRIPT URLɬפ
	if(${$mode}{SCRIPTURL}){
		$tmpl->param(SCRIPT_URL => $BD::gScriptURL);
	}

	# ƥץ졼
	if(${$mode}{LOGIN}){
		$tmpl->param(GAME_NAME => $bd->{gameName});

		my $gidx = 0;
		foreach my $gname ( @BD::gGameList) {
			if($gname eq $bd->{gameName}){
				$gameidx = $idx;
				last;
			}
			$gidx++;
		}
		$tmpl->param(GAME_INDEX => $gidx);

		my $gcnt = $#BD::gGameList + 1;

		$tmpl->param(GAME_COUNT => $gcnt);
		$tmpl->param(GAME_PLURAL => ($gcnt>1));


		# for TMPL_LOOP
		my @glist = ();
		my @glist2 = ();
		my $idx = 0;
		my $glHash;
		foreach $key (@BD::gGameList) {
			my $name = $BD::gGameTitleList{ $key };
			my $info = $BD::gGameInfo{ $key };
			my $issel;
			
			if($bd->{gameName} eq $key){
				$issel = 'SELECTED';
			} else {
				$issel = '';
			}
			# \n<br>ѴϤ(ʳϥפ)
			$info = bdUtil::sanitize($info);
			$info = bdUtil::Replace($info,'\\\n',"<br>");


			push @glist, {  title => $name , name => $key, selected => $issel };
			push @glist2, { idx => $idx, info => $info };
			$idx++;
		}

		$tmpl->param(GAME_INFO => \@glist );
		$tmpl->param(GAME_INFO2 => \@glist2 );

		$tmpl->param(SCRIPT_URL_USERADDFORM => $BD::gScriptURL_UserAddForm);
	}

	# COOKIE_USERɬפݤ
	if(${$mode}{COOKIE_USER}){
		$tmpl->param(COOKIE_USER => $session->param("inputUser"));
	}


	# GAMETITLEɬפݤ
	if(${$mode}{GAMETITLE}){
		my $title = $bd->{gameTitle};
		if(!$title){
			$title = $BD::gGameTitleList{ $bd->{gameName} };
		}
		$tmpl->param(GAMETITLE => $title);
	}

	# 
	if(${$mode}{GAME}){
		$tmpl->param(BGMOPEN => $bd->{bgmOpen} );
		$bd->{bgmOpen} = 0;
	
		$tmpl->param(LOGINUSER => $bd->{loginUser} );
		if($bd->isExistMagick()){
			# Image::Magick硢ͭ
			my $scw = $bd->{scr_x} * $bd->{scr_scale};
			my $sch = $bd->{scr_y} * $bd->{scr_scale};
			# 
			my $gx = $bd->{grp_x};
			my $gy = $bd->{grp_y};
#			$tmpl->param(CANVAS_IMAGE_TAG => '<div class="graphics"  style="padding-left: auto; padding-right: auto; margin-left: ' . $gx . 'px; margin-right: ' . ($gx*-1) . 'px; margin-top: ' . $gy . 'px; text-align: center; border: 1px solid #fff;"><img src="' . $bd->{ScreenImageFile} . '?' . time() .'" width="' . $scw . '" height="' . $sch . '"></div>');
			$tmpl->param(CANVAS_IMAGE_TAG => '<img src="' . $bd->{ScreenImageFile} . '?' . time() .'" width="' . $scw . '" height="' . $sch . '" style="padding-left: auto; padding-right: auto; margin-left: ' . $gx . 'px; margin-right: ' . ($gx*-1) . 'px; margin-top: ' . $gy . 'px; text-align: center;">');
		} else {
			# Image::Magick̵硢ϤβΤΤ򤽤Τޤ޻Ȥ
			$tmpl->param(CANVAS_IMAGE_TAG => '<img src="' . $bd->{ScreenImageFile} . '" style="padding-left: auto; padding-right: auto; margin-left: ' . $gx . 'px; margin-right: ' . ($gx*-1) . 'px; margin-top: ' . $gy . 'px; text-align: center;">');
		}
		{
			my $mx = $bd->{msg_x};
			my $my = $bd->{msg_y};
			if($mx ne 'auto'){
				$mx .= 'px';
			}
			if($my ne 'auto'){
				$my .= 'px';
			}
			$tmpl->param(MSG_STYLE => 'style="border: 1px solid #fff; margin-left: ' . $mx . '; margin-right: auto; margin-top: ' . $my . ';"');
		}
		$tmpl->param(GAME_MESSAGE => $bd->{outputStr});
		$tmpl->param(ERR => ($bd->{errorStr} ne ''));
		$tmpl->param(ERROR_MESSAGE => $bd->{errorStr});
		$tmpl->param(LOGIN_COUNT => "$loginCount");
		$tmpl->param(LOGIN_COUNT_MAX => bdConst::MAX_USER);

		$tmpl->param(SCRIPT_URL_BACKLOG => $BD::gScriptURL_Backlog);
		$tmpl->param(SCRIPT_URL_KEYWORD => $BD::gScriptURL_Keyword);

		$tmpl->param(DISP_KW  => $BD::gDispKwLink);
		$tmpl->param(DISP_LOG => $BD::gDispLogLink);

		$tmpl->param(SUBWINDOW => $bd->get_subwin_html() );

		$tmpl->param(NOLOGIN  => $BD::gNoLogin);
	}
	# Хå
	if(${$mode}{BACKLOG}){
		my $txt = $bd->{backlog}->get_text();
		$tmpl->param(BACKLOGTEXT => $txt);
	}

	# 
	if(${$mode}{KEYWORD}){
		my $txt = $bd->{keyWords}->get_text();
		$tmpl->param(KEYWORDTEXT => $txt);
	}
}


# ե
sub requireLogin {
	my $template = HTML::Template->new(filename => "$BD::gTemplatesPath/login.tmpl");

	setTemplateParams( $template ,{ LOGIN=>1, SCRIPTURL=>1, COOKIE_USER=>1 });

	print $template->output;

	exit;
}

# 󥨥顼
sub loginError {
	my $err = shift;


	my $template = HTML::Template->new(filename => "$BD::gTemplatesPath/login.tmpl");

	setTemplateParams( $template, {LOGIN=>1, SCRIPTURL=>1, COOKIE_USER=>1} );

	$template->param(ERROR_MSG, "顼$err" );

	print $template->output;

	exit;

}

# 桼Ͽե
sub userAddForm {

	my $template = HTML::Template->new(filename => "$BD::gTemplatesPath/regist.tmpl");

	setTemplateParams( $template, {REGIST=>1, SCRIPTURL=>1,COOKIE_USER=>1} );

	print $template->output;

	exit;
}

# 桼Ͽμ¹
sub userAddExec {
	my $user = $cgi->param("user");
	my $pass = $cgi->param("pass");
	my $pass2 = $cgi->param("pass2");
	my $err;

	# åľ񤭤ϤʤġĤޤ
	if(!($user =~ /^[a-zA-Z][a-zA-Z0-9_\-]+$/)){
		# 桼̾
		$err = "桼̾Ǥ桼̾(ȾѱѿΤ)ϤƤ";
	} elsif(!($pass =~ /^[a-zA-Z][a-zA-Z0-9]+$/)){
		# ѥɤ
		$err = "ѥɤǤѥ(ȾѱѿΤ)ϤƤ";
	} elsif($pass ne $pass2){
		# ѥɤ㤦
		$err = "ѥɤϥߥǤѥ(ȾѱѿΤ)ϤƤ";
	}
	if($auth->search( $user )){
		$err = "$user ϴϿѤǤ̤Υ桼̾ϿƤ";
	}

	if($err){
		my $template = HTML::Template->new(filename => "$BD::gTemplatesPath/regist.tmpl");

		$template->param(ERROR_MSG, "顼$err");

		setTemplateParams( $template, {REGIST=>1, SCRIPTURL=>1,COOKIE_USER=>1} );
		print $template->output;
	} else {
		# ϿǤ⥲̤(ꤷƤ뤱ɥ桼ˤϤΰռϤʤ)ʤΤǥȥåפ롣
		$auth->add_user($user,$pass);
		$session->param("inputUser", $user);

#		$auth->login($user,$pass);
#		# ʳǰå¸
#		$bd->save_to_session($session);

		my $template = HTML::Template->new(filename => "$BD::gTemplatesPath/success.tmpl");

		setTemplateParams( $template, {INFO=>1, SCRIPTURL=>1} );

		print $template->output;
	}
	exit;
}

# Хåɽ
sub dispBacklog {
	my $template = HTML::Template->new(filename => "$BD::gTemplatesPath/backlog.tmpl");

	setTemplateParams( $template, {BACKLOG=>1,GAMETITLE=>1} );

	print $template->output;

	exit;
}

# ɤɽ
sub dispKeywords {
	my $template = HTML::Template->new(filename => "$BD::gTemplatesPath/keywords.tmpl");

	setTemplateParams( $template, {KEYWORD=>1,GAMETITLE=>1} );

	print $template->output;

	exit;
}

# BGMκ
sub dispBgm {
	my $template = HTML::Template->new(filename => "$BD::gTemplatesPath/bgm.tmpl");

	setTemplateParams( $template, {BGM=>1} );

	print $template->output;

	exit;
}



1;
