######################################################################
##饹    : CGI::Session::Sweeper                                 ##
##      : ᥤ󥯥饹                                          ##
##                                                                  ##
######################################################################
package CGI::Session::Sweeper;
require Exporter;

our @ISA = qw(Exporter);

our %EXPORT_TAGS = ( 'all' => [ qw(
    
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
    
);

our $VERSION = '0.01';

#󥹥ȥ饯
#      :$_[0],  I,  Scaler,  DSN     (CGI::Session->new 1Ʊ)
#           $_[1],  I,  HashRef, HASHREF (CGI::Session->new 3Ʊ)
sub new {
    my $class   = shift;
    $class      = ref( $class ) || $class;
    my @api_3;
    
    if ( defined $_[0] ) {
        @api_3  =
            map { uc( $_->[0] ) => $_->[1] } 
            map { [ /^(.+):(.+)$/ ] } 
                            split /;/, $_[0] ;
    }
    
    my $self = {
        _OPTIONS    => [ @_ ], 
        _API_3      => {
            DRIVER      => 'File', 
            SERIALIZER  => 'Default', 
            ID          => 'MD5', 
            @api_3
        }
    };
    
    # ɥ饤Фб륵֥饹bless
    $class  .= "::$self->{_API_3}->{DRIVER}";
    return bless( $self, $class );
}


#å
#      :ʤ
sub sweep {
    # sweep ! :)
    my $self        = shift;
    my %sessions    = %{ $self->_scan_sessions() };
    my @args;
    
    $args[0, 2]     = @{ $self->{_OPTIONS} }[0, 1];
    
    while ( my( $id, $val ) = each %sessions ) {
        next unless( $id );
        $args[1]        = $id;
        my $oSubItem    = CGI::Session::Sweeper::Item->new( @args );
        # CGI::Session->new()
        #   CGI::Session::Sweeper::Item->_init_old_session()뤵
        
        undef( $oSubItem );
    }
    return 1;
}

#å
#      :ʤ
#      :ߥǥ¸ߤ륻å󤷤HashRef֤
#            ƥɥ饤ФȤΥ֥饹饪Сɤ
#    :{ åID => ɥ饤Ǥμ̻ҤȤ(Ǥ⤤) }
sub _scan_sessions { return {} }



######################################################################
##饹    : CGI::Session::Sweeper::Item                           ##
##      : 줾ΥåˤĤơͭ¤Ĵ١        ##
##          : ڤʤ鳫˺                              ##
##            CGI::SessionѾ                                ##
######################################################################
package CGI::Session::Sweeper::Item;

use CGI::Session;

#ʤ᥽åɤ򥪡Сɤ褦!
our @ISA = qw(CGI::Session);

#󥹥ȥ饯
#      :$_[0],  I,  Scaler,         DSN     (CGI::Session->new 1Ʊ)
#           $_[1],  I,  Scaler or CGI,  SID     (CGI::Session->new 2Ʊ)
#           $_[2],  I,  HashRef,        HASHREF (CGI::Session->new 3Ʊ)
sub new {
    my $class   = shift;
    $class      = ref( $class ) || $class;
    
    # ƥ饹
    my $self    = CGI::Session->new( @_ );
    
    return bless( $self, $class );
    
}


#¸Υåɤ
#      :$_[1],  I,  Scaler, åID
#      :CGI::Session->_initꥳ뤵
#           ѡ饹Υ᥽åɤꡢåդ
#           ꤹ򥳥ȥȤΤ
#    : undef, ʳ 1
sub _init_old_session {
    my ($self, $claimed_id) = @_;

    my $options = $self->{_OPTIONS} || [];
    my $data = $self->retrieve($claimed_id, $options);
    
    # Session was initialized successfully
    if ( defined $data ) {

        $self->{_DATA} = $data;

#        # Check if the IP of the initial session owner should
#        # match with the current user's IP
#        if ( $IP_MATCH ) {
#            unless ( $self->_ip_matches() ) {
#                $self->delete();
#                $self->flush();
#                return undef;
#            }
#        }

        # Check if the session's expiration ticker is up
        if ( $self->_is_expired() ) {
            $self->delete();
            $self->flush();
#            return undef;
        }

#        # Expring single parameters, if any
#        $self->_expire_params();

#        # Updating last access time for the session
#        $self->{_DATA}->{_SESSION_ATIME} = time();

#        # Marking the session as modified
#        $self->{_STATUS} = MODIFIED;

        return 1;
    }
#    return undef;
    return 1;   #ξ1֤
}

######################################################################
##饹    : CGI::Session::Sweeper::File                           ##
##      : CGI::Session::Sweeper֥饹(driver:File)      ##
##          : å󤹤                                  ##
##                                                                  ##
######################################################################
package CGI::Session::Sweeper::File;
our @ISA    = qw(CGI::Session::Sweeper);

#å
#      :ʤ
#      :ߥǥ¸ߤ륻å󤷤HashRef֤
#            ƥɥ饤ФȤΥ֥饹饪Сɤ
#    :{ åID => ե̾ }
sub _scan_sessions {
    
    my $self    = shift;
    my $dir     = $self->{_OPTIONS}[1]{Directory} || '.';
    my $pat     = sprintf( $CGI::Session::File::FileName, '(.+)' );
    
    # ǥ쥯ȥꥪץ
    opendir( DIRH, $dir ) or croak( "can't open directory" );
    
    #  ƵϤʤΤȤ
    my %sessions = 
        map { $_->[1] => $_->[0] }
        map { [ /^($pat)/ ] }
                                readdir( DIRH );
    
    # 
    closedir( DIRH );
    
    return \%sessions;
    
}


1;
__END__
