# 
# bdBacklog.pm
# 
#   BLACK DIAMOND Хå饹
#
# Copyright 2005 ONODA Production 
#
# $Id: bdBacklog.pm,v 1.1 2005/02/01 04:38:24 onoda Exp $

package bdBacklog;

# 󥹥ȥ饯
sub new{
	my $pkg = shift;

	bless {},$pkg;
}

# Хåؤɲ($str)
sub add {
	my $self  = shift;
	my $str = shift;

	push @{ $self->{logs} }, $str;
}

# Хåμ(󻲾)
sub get_all {
	my $self  = shift;

	return $self->{logs};
}

# ХåԤĤƥȤˤƼ
sub get_text {
	my $self  = shift;
	my $strs;

	$strs = join "<BR>\n", @{ $self->{logs} };

	return $strs;
}

# ХåΥꥢ
sub clear{
	my $self  = shift;

	$self->{logs} = ();
}

# ХåιԿ
sub count{
	my $self  = shift;

	return $#{ $self->{logs} } + 1;
}


# ХåԿʾˤʤäƤ饫å
sub reduce {
	my $self  = shift;
	my $linenum = shift;

	my $cnt = $self->count();
	while( $cnt > $linenum){
		shift @{ $self->{logs} };
		$cnt--;
	}

}

# ʸ˥ꥢ饤(ɥ)
sub serialize{
	my $self  = shift;

	my $datas;
	my $cnt = $self->count();		# $#{ $self->{items} };

	$datas = "$cnt,";

	# CSV(֥륯Ȥޤϥޤޤ硢""Ǥ졢"""ˤʤ)
	# URL : http://www.din.or.jp/%7Eohzaki/perl.htm#CSVfromValues
	my @arr = @{ $self->{logs} };
	$datas .= join ',', map {(s/"/""/g or /[\r\n,]/) ? qq("$_") : $_} @arr;

	return $datas;
}


# ʸ󤫤ǥꥢ饤(ɥ)
sub deserialize{
	my $self  = shift;
	my $line  = shift;
	my $cnt;

	my @values = ();

	# ᤹
	# URL : http://www.din.or.jp/%7Eohzaki/perl.htm#CSV2Values
	{
		my $tmp = $line;
		$tmp =~ s/(?:\x0D\x0A|[\x0D\x0A])?$/,/;
		@values = map {/^"(.*)"$/ ? scalar($_ = $1, s/""/"/g, $_) : $_}
		($tmp =~ /("[^"]*(?:""[^"]*)*"|[^,]*),/g);
	}

	$cnt = shift @values;
	# ĿåƤ(ޤ̣ʤ)
	if($cnt != 0){
		@{$self->{logs}} = @values;
	} else {
		@{$self->{logs}} = ();
	}

}


# ǥȥ饯
sub DESTROY
{
    my $self = shift;
    undef @{$self->{logs}};
}


1;
