#
# BLACK DIAMOND on Web Υ󥿡ץ꥿(٤)
#
# Copyright 2005 ONODA Production 
#
# $Id: bdExpr.pm,v 1.3 2005/02/01 04:38:24 onoda Exp $


package bdExpr;

use bdCommon;
use bdUtil;

sub init {
	$stack_point = 1;
#	$str_point = 0;
	
	$now_token = (
		tokType => -1,
		value => 0,
		str => undef
	);
	%t1 = ();
	%t2 = ();

	$tmpstr = '';

	@tmpstra = ();

	@symbol_name = (
		'&&', '||', '==', '<=', '>=', '!=','<>','=~','!~',
		'+=','-=','*=','/=','%=','<<=','>>=','&=','|=','^=',
		'<<','>>','|','&','?',':','^',
		'++','--',
		'*', '/', '%', '+', '-', '<', '>', '=', '(', ')',
		'}'
	);
	
	@tokStack = ();
	%t1 = ();

}
my $TYPE_VALUE = 1;
my $TYPE_STRING = 2;

my $eucpre = qr{(?<!\x8F)};
my $eucpost= qr{
	    (?=                         
		(?:[\xA1-\xFE][\xA1-\xFE])* # JIS X 0208  0ʸʾ³
		(?:[\x00-\x7F\x8E\x8F]|\z)  # ASCII, SS2, SS3 ޤϽü
		)
	}x;
my $unget_char = '';

sub factor6 {
	my $tp;
	my $val;
	my $op;

	# ++--
	$op  = $now_token{tokType};
	if( ($op eq '++') || ($op eq '--') ){
		&read_token;
		&factor6;
		&pop_stack(\%t1);
		%t2 = %t1;

		if($t1{tokType} eq $TYPE_VALUE){
		} elsif( ($t1{tokType} eq $TYPE_STRING) || ($t1{tokType} eq 'S')) {
			print 'ʸϥ󥯥ȡǥȽޤ\n';
			return;
		} elsif( $t1{tokType} eq 'F') {
			if (($t1{value} >= 8192) || ($t1{value} < 0)) {
				print "Error : ե饰ѿΥǥåǤ";
				return;
			}

			$val = $BD::gFlags->value( $t1{value} );
			if($op eq  '++'){
				$val++;
			} else {
				$val--;
			}
			$BD::gFlags->set_flag( $t1{value} , $val );
		} elsif($t1{tokType} eq 'I') {
			if(!$BD::gItems->is_exists($t1{str})){
				print "顼ƥ' + $t1{str} + 'ޤ\n";
				return;
			}
			$val = $BD::gItems->value( $t1{str} );
			if($op eq  '++'){
				$val++;
			} else {
				$val--;
			}
			$BD::gItems->set_item( $t2{str}, $t2{value} );
		}  else {
			$t2{value}++;
		}
		set_var(\%t2);			# ᤹

		&push_stack(\%t2);	# ᤹(֤ʤΤǥ󥯥ȸͤ)
	} elsif($op eq '-') {
		# ñ
		&read_token;
		&factor6;
		&pop_stack(\%t1);
		&set_var(\%t1);
		$t1{tokType} = $TYPE_VALUE;
		$t1{value} = $t1{value} * -1;
		&push_stack(\%t1);
	} elsif($op eq '(') {
		&read_token;
		&factor1;
		if($now_token{tokType} eq ')') {
			&read_token;
		} else {
			print '()԰פޤ';
		}
	} elsif($op eq $TYPE_VALUE) {	# 
		&push_stack(\%now_token);
		&read_token;
	} elsif($op eq $TYPE_STRING) {	# ʸ
		&push_stack(\%now_token);
		&read_token;
	} elsif (($op eq 'F') || ($op eq 'S')) {
		$tp = $op;
		&read_token;		# ɬ'('ΤϤġ
		if($now_token{tokType} ne '('){
			print 'ѿεҤǤ1';
			return
		}
		&read_token;		# ʤΤФƼ餤
		&factor1;
		&pop_stack(\%t1);
		&set_var(\%t1);		# Υǥåᤵʤȡġ(2003/8/27)
		if ($t1{tokType} eq $TYPE_STRING) {		# ʸξϡʸѴ
			$t1{value} = $t1{str};		# ɤ
		}

		if ( ($t1{tokType} ne $TYPE_VALUE) && ($t1{tokType} ne $TYPE_STRING) ) {
			print 'ѿεҤǤ2';
			return;
		}

		$t2{tokType} = $tp;
		$t2{value}   = $t1{value};
		&push_stack(\%t2);		# ѿΤޤ¸

		if($now_token{tokType} eq ')') {
			&read_token;
		} else {
			print 'ѿ()԰פޤ';
		}
	} elsif($now_token{tokType} eq 'I') {
		$tp = $op;
		&read_token;		# ɬ'('ΤϤġ
		if($now_token{tokType} ne '('){
			print 'ѿεҤǤ3';
			return
		}
		&read_token;		# ʤΤФƼ餤
		&factor1;
		&pop_stack(\%t1);
		if ($t1{tokType} ne $TYPE_STRING) {
			print "ƥѿεҤǤ";
			return;
		}

		$t2{tokType} = 'I';
		$t2{value}  = 0;		# ϥƥ।ǥåƤ٤
		$t2{str} = $t1{str};
		&push_stack(\%t2);		# ѿΤޤ¸

		if($now_token{tokType} eq ')') {
			&read_token;
		} else {
			print 'ѿ()԰פޤ';
			return;
		}
	} elsif( $now_token{tokType} eq 'R') {
		$tp = $op;
		&read_token;		# ɬ'('ΤϤġ
		if($now_token{tokType} ne '('){
			print 'ѿεҤǤ4';
			return
		}
		&read_token;		# ʤΤФƼ餤
		&factor1;
		&pop_stack(\%t1);
		&set_var(\%t1);		# ѿѴޤäƤʤä

		# 0t1ޤǤΥͤ
		if ( $t1{tokType} eq $TYPE_STRING ) {
			$t1{TokType} = $TYPE_VALUE;
			$t1{value} = $t1{str};
		}

		# ͤǤ0valueޤǤͤФΤ1­Ƥ
		# ǥˡ0value-1ǺäƤäΤ
		# ޥ˥奢񤭴뤳Ȥˤ
		$t1{value} = int( rand ($t1{value}+1) );		# ܤäȤȤĴ٤

		&push_stack(\%t1);		# ͤ¸

		if($now_token{tokType} eq ')') {
			&read_token;
		} else {
			print '()԰פޤ';
			return;
		}
	} elsif ($now_token{tokType} eq 'X') {
		# ǸϤ줿ʸִ(äȤα)
		$t1{tokType} = $TYPE_STRING;
		$t1{value} = 0;
		$t1{str} = '';
		&push_stack(\%t1);
#		read_token();
	} else {
		print 'ʥȡ󤬻ѤƤޤ';
	}
}

# factor5Ȥfactor61Ĥ*ס/ס%פǷФ줿ΤǤ }
sub factor5 {
	my $val;

	factor6();
	while(1){
		my $op = $now_token{tokType};
		if(($op eq '++') or ($op eq '--')){
			&read_token;
			&pop_stack(\%t1);
			%t2 = %t1;
			&set_var(\%t2);			# ᤹

			if($t1{tokType} eq $TYPE_VALUE){
			} elsif( ($t1{tokType} eq $TYPE_STRING) || ($t1{tokType} eq 'S')) {
				print 'ʸϥ󥯥ȡǥȽޤ\n';
				return;
			} elsif($t1{tokType} eq 'F') {
				if (($t1{value} >= 8192) || ($t1{value} < 0)) {
					print "Error : ե饰ѿΥǥåǤ";
					return;
				}
				$val = $BD::gFlags->value( $t1{value} );
				if($op eq  '++'){
					$val++;
				} else {
					$val--;
				}
				$BD::gFlags->set_flag( $t1{value} , $val );
			} elsif($t1{tokType} eq 'I') {
				if(!$BD::gItems->is_exists($t1{str})){
					print "顼ƥ' + $t1{str} + 'ޤ\n";
					return;
				}
				$val = $BD::gItems->value( $t1{str} );
				if($op eq  '++'){
					$val++;
				} else {
					$val--;
				}
				$BD::gItems->set_item( $t2{str}, $t2{value} );
			}

			&push_stack(\%t2);	# ᤹(֤ʤΤǥ󥯥ͤ)
		} elsif( ($op eq '*') ||
				 ($op eq '/') ||
				 ($op eq '%')){
			&read_token;
			&factor6;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);
			$t1{tokType} = $TYPE_VALUE;
			
			if($op eq '*'){
				$t1{value} = $t1{value} * $t2{value};
			} elsif($op eq '/'){
				$t1{value} = $t1{value} / $t2{value};
			} else {
				$t1{value} = $t1{value} % $t2{value};
			}

			push_stack(\%t1);

		} else {
			last;
		}
	}
}

# factor4Ȥfactor51Ĥ+ס-פǷФ줿ΤǤ
sub factor4 {

	&factor5;
	while(1) {
		if($now_token{tokType} eq '+') {
			&read_token;
			&factor5;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);

			if( ($t1{tokType} eq $TYPE_STRING) || ($t2{tokType} eq $TYPE_STRING)) {
				# ʸ­
				if( $t1{tokType} ne $TYPE_STRING) { $t1{str} = $t1{value}; }
				if( $t2{tokType} ne $TYPE_STRING) { $t2{str} = $t2{value}; }

				$t1{tokType} = $TYPE_STRING;
				$t1{str} = $t1{str} . $t2{str};
			} else {
				$t1{tokType} = $TYPE_VALUE;
				$t1{value} = $t1{value} + $t2{value};
			}

			&push_stack(\%t1);
		} elsif( $now_token{tokType} eq '-') {
			&read_token;
			&factor5;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);
			$t1{tokType} = $TYPE_VALUE;
			$t1{value} = $t1{value} - $t2{value};
			&push_stack(\%t1);
		} else {
			last;
		}
	}

}

# factor3_5Ȥfactor41Ĥ<<ס>>פǷФ줿ΤǤ
sub factor3_5 {

	&factor4;
	while(1) {
		if( ($now_token{tokType} eq '<<') or 
		    ($now_token{tokType} eq '>>')){
			my $op = $now_token{tokType};
			&read_token;
			&factor4;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);
			$t1{tokType} = $TYPE_VALUE;

			if($op eq '<<'){
				$t1{value} = $t1{value} << $t2{value};
			} else {
				$t1{value} = $t1{value} >> $t2{value};
			}

			push_stack(\%t1);
		} else {
			last;
		}
	}
}

# factor3Ȥfactor3_51Ĥ==ס<ס>ס<=ס>=ס!=ס<>ס=~ס!~פ
# Ф줿ΤǤ                                           }
sub factor3 {
	my $isContain;

	&factor3_5;
	while(1){
		my $op = $now_token{tokType};
		if( ($op eq '==') ||					# ʸȿñӷ
		    ($op eq '!=') ||
			($op eq '<>')){
			&read_token();
			&factor3_5();
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);

			if( ($t1{tokType} eq $TYPE_STRING) || ($t2{tokType} eq $TYPE_STRING) ){
				# ʸ
				if( $t1{tokType} ne $TYPE_STRING) { $t1{str} = $t1{value}; }
				if( $t2{tokType} ne $TYPE_STRING) { $t2{str} = $t2{value}; }

				if($op eq '=='){
					$t1{value} = ($t1{str} eq $t2{str}) ? 1 : 0;
				} else {
					$t1{value} = ($t1{str} ne $t2{str}) ? 1 : 0;
				}
			} else {
				# ͤ
				if( $t1{tokType} eq $TYPE_STRING) { $t1{value} = $t1{str}; }
				if( $t2{tokType} eq $TYPE_STRING) { $t2{value} = $t2{str}; }


				if($op eq '=='){
					$t1{value} = ($t1{value} == $t2{value}) ? 1 : 0;
				} else {
					$t1{value} = ($t1{value} != $t2{value}) ? 1 : 0;
				}
			}
			$t1{tokType} = $TYPE_VALUE;
			&push_stack(\%t1);
		} elsif( ($op eq '<') ||		# ɸͥå
				 ($op eq '>') ||		# < > <= >=
				 ($op eq '<=') ||
				 ($op eq '>=')){

			&read_token();
			&factor3_5();
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);

			$t1{tokType} = $TYPE_VALUE;
			# $opˤӤѹ
			SELECT:
			{
				$op eq '<' && do {
					$t1{value} = ($t1{value} < $t2{value})?1:0;
					last SELECT ;
				};
				$op eq '>' && do {
					$t1{value} = ($t1{value} > $t2{value})?1:0;
					last SELECT ;
				};
				$op eq '>=' && do {
					$t1{value} = ($t1{value} >= $t2{value})?1:0;
					last SELECT ;
				};
				$op eq '<=' && do {
					$t1{value} = ($t1{value} <= $t2{value})?1:0;
					last SELECT ;
				};
				# print "No Match ";
			}
			&push_stack(\%t1);
		} elsif( ($now_token{tokType} eq '=~') or ($now_token{tokType} eq '!~')) {
			$isContain = ($now_token{tokType} eq '=~');
			# ʸޤफɤΥå
			&read_token;
			&factor3_5;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);

			if( $t1{tokType} ne $TYPE_STRING) { $t1{str} = $t1{value}; }
			if( $t2{tokType} ne $TYPE_STRING) { $t2{str} = $t2{value}; }

			# ޤफɤå
			$t1{value} = (index( $t1{str}, $t2{str}) != -1)?1:0;

			if(!$isContain){	# ִޤޤʤȽξ01ȿž
				$t1{value} = $t1{value} ^ 1;
			}
			$t1{tokType} = $TYPE_VALUE;

			&push_stack(\%t1);
		} else {
			last;
		}
	}

}

# factor2_5Ȥfactor31Ĥ&ס|ס^פǷФ줿ΤǤ
sub factor2_5 {
	&factor3;
	while(1) {
		if ($now_token{tokType} eq '&') {
			&read_token;
			&factor3;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);
			$t1{tokType} = $TYPE_VALUE;
			$t1{value} = ($t1{value} & $t2{value});
			&push_stack(\%t1);
		} elsif ($now_token{tokType} eq '|') {
			&read_token;
			&factor3;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);
			$t1{tokType} = $TYPE_VALUE;
			$t1{value} = ($t1{value} | $t2{value});
			&push_stack(\%t1);
		} elsif ($now_token{tokType} eq '^') {
			&read_token;
			&factor3;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);
			$t1{tokType} = $TYPE_VALUE;
			$t1{value} = ($t1{value} ^ $t2{value});
			&push_stack(\%t1);
		} else {
			last;
		}
	}
}

# factor2Ȥfactor2_51Ĥ&&ס||פǷФ줿ΤǤ
sub factor2 {

	&factor2_5;
	while(1) {
		if( ($now_token{tokType} eq  '&&') ){
			&read_token;
			&factor2_5;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);
			$t1{tokType} = $TYPE_VALUE;
			$t1{value} = ($t1{value} && $t2{value});
			push_stack(\%t1);
		} elsif( ($now_token{tokType} eq  '||') ){
			&read_token;
			&factor2_5;
			&pop_stack(\%t2);
			&pop_stack(\%t1);
			&set_var(\%t1);
			&set_var(\%t2);
			$t1{tokType} = $TYPE_VALUE;
			$t1{value} = ($t1{value} || $t2{value});
			&push_stack(\%t1);
		} else {
			last;
		}
	}

}

# factor1_5Ȥϻ黻ҤǤ
sub factor1_5 {
	my $flg;

	&factor2;

	while(1) {
		if( $now_token{tokType} eq '?') {
			pop_stack(\%t1);
			set_var(\%t1);
#			if($t1{value} == 1){
#				flg := true
#			} else {
#				flg := false;
#			}
			$flg = $t1{value};

			&read_token;
			&factor1;

			if($now_token{tokType} ne ':'){
				print '黻ҤǤ\n';
				return;
			}
			&read_token;
			&factor1;

			pop_stack(\%t2);	# :α¦
			pop_stack(\%t1);	# :κ¦
			set_var(\%t1);
			set_var(\%t2);

			if($flg){
				push_stack(\%t1)
			} else {
				push_stack(\%t2);
			}

		} else {
			last;
		}
	}
}




# factor1Ȥfactor21Ĥ=פǷФ줿ΤǤ롣
#  뤤+= -= *= /= %= &= |= ^= ǷФ줿ΤǤ롣}
# PerlŪˤϰ۾˾ĹݤʤΤǽʤ
sub factor1 {
	my $val;
	my $op;
	my %tmptk = ();


	&factor1_5;

	while (1) {
		if(($now_token{tokType} eq '=') ||
		   ($now_token{tokType} eq '+=') ||
		   ($now_token{tokType} eq '-=') ||
		   ($now_token{tokType} eq '/=') ||
		   ($now_token{tokType} eq '*=') ||
		   ($now_token{tokType} eq '%=') ||
		   ($now_token{tokType} eq '<<=') ||
		   ($now_token{tokType} eq '>>=') ||
		   ($now_token{tokType} eq '&=') ||
		   ($now_token{tokType} eq '^=') ||
		   ($now_token{tokType} eq '|=')){
			$op = $now_token{tokType};

			read_token();
			factor1_5();

			pop_stack(\%t2);
			pop_stack(\%t1);

			if( ($t1{tokType} ne ('F')) && ($t1{tokType} ne 'I') && ($t1{tokType} ne 'S')){
				# script error!
				print "褬ѿǤϤޤ $t1{tokType}\n";
				return;
			}

			%tmptk = %t1;
			set_var(\%tmptk);
			set_var(\%t2);

			# ٤ͤt2äƤ
			if ($t1{tokType} ne 'S'){		# 

				if ($t2{tokType} eq $TYPE_STRING){			# ΤդʸʤΤǿˤ
					$t2{value} = $t2{str};
				}

#				if op = OP_EQ         then t2.value := t2.value			// ̣ʤ
				if ( $op eq '+=') { $t2{value} = $tmptk{value} + $t2{value};
				} elsif( $op eq '-=' ) { $t2{value} = $tmptk{value} - $t2{value};
				} elsif( $op eq '/=' ) { $t2{value} = $tmptk{value} / $t2{value};
				} elsif( $op eq '*=' ) { $t2{value} = $tmptk{value} * $t2{value};
				} elsif( $op eq '%=' ) { $t2{value} = $tmptk{value} % $t2{value};
				} elsif( $op eq '<<=' ) { $t2{value} = $tmptk{value} << $t2{value};
				} elsif( $op eq '>>=' ) { $t2{value} = $tmptk{value} >> $t2{value};
				} elsif( $op eq '&=' ) { $t2{value} = $tmptk{value} & $t2{value};
				} elsif( $op eq '|=') { $t2{value} = $tmptk{value} | $t2{value};
				} elsif( $op eq '^=' ) { $t2{value} = $tmptk{value} ^ $t2{value}; }

			} else {						# ʸ
				if ($t2{tokType} eq $TYPE_VALUE){			# ΤդͤʤΤʸˤ
					$t2{str} = $t2{value};
				}

				$t2{tokType} = $TYPE_STRING;

				if ($tmptk{tokType} eq $TYPE_VALUE) {		# Τդξ
					$tmptk{tokType} = $TYPE_STRING;
					$tmptk{str} = $tmptk{value};
				}

				if($op eq '+='){
					$t2{str} = $tmptk{str} . $t2{str};
				}
			}

			# 

			if ($t1{tokType} eq 'F') {			# ե饰ѿ
				if (($t1{value} >= 8192) || ($t1{value} < 0)) {
					print "Error : ե饰ѿΥǥåǤ";
					return;
				}
				$BD::gFlags->set_flag( $t1{value} , $t2{value} );
			} elsif ($t1{tokType} eq 'I') {		# ƥѿ
				if(!$BD::gItems->is_exists($t2{str})){
					print "顼ƥ'$t2{str}'ޤ\n";
					return;
				}
				$BD::gItems->set_item( $t2{str}, $t2{value} );

			} elsif ($t1{tokType} eq 'S') {		# ʸѿ
				if (($t1{value} >= 1024) || ($t1{value} < 0)) {
					print "Error : ʸѿΥǥåǤ";
					return;
				}

				if ($t2{tokType} eq $TYPE_VALUE) {
					# ͤʸѴ
					$BD::gStrings->set_string($t1{value}, $t2{value});
				} elsif($t2{tokType} eq $TYPE_STRING) {
					# ʸʸΤޤ
					$BD::gStrings->set_string($t1{value}, $t2{str});
				}
			}

			if ($t2{tokType} ne $TYPE_STRING) {
				$t2{tokType} = $TYPE_VALUE;
			}
			push_stack(\%t2);
		} else {
			last;
		}
	}
}



# ѿŸ
sub set_var {
	my $tk = shift;
	my $val;

	if($$tk{tokType} eq 'F'){							# ե饰ѿ
		$$tk{tokType} = $TYPE_VALUE;
		if(($$tk{value} >= 8192) or ($$tk{value} < 0)){
			# 顼ե饰ѿΥǥåǤ
			return;
		}
		$$tk{value} = $BD::gFlags->value( $$tk{value} );
	} elsif($$tk{tokType} eq 'I'){						# ƥѿ
		$$tk{tokType} = $TYPE_VALUE;
		if(!$BD::gItems->is_exists($$tk{str})){
			# 顼ƥ' + $$tk{str} + 'ޤ');
			return;
		}
		$$tk{value} = $BD::gItems->value( $$tk{str} );
	} elsif($$tk{tokType} eq 'S'){						# ʸѿ
		$$tk{tokType} = $TYPE_STRING;
		if(($$tk{value} >= 1024) or ($$tk{value} < 0)){
			# 顼ʸѿΥǥåǤ
			return;
		}
		$$tk{str} = $BD::gStrings->value( $$tk{value} );
	}
}

# å˥ȡϥåϿ(Ȥ㤦ΤǡβƤ餽μΤΥե󥹤Ǽ)
sub push_stack {
	my $val = shift;
	my %newhash = %{$val};

	push @tokStack,\%newhash;
}

# åȡϥå򽦤
sub pop_stack {
	my $pval = shift;

	%$pval = %{pop @tokStack};
}


# tmpstr1ʸ(ޤ)
sub get_char {
	my $ascii = '[\x00-\x7F]';
	my $twoBytes = '[\x8E\xA1-\xFE][\xA1-\xFE]';
	my $threeBytes = '\x8F[\xA1-\xFE][\xA1-\xFE]';

	$char = -1;
	if ($tmpstr =~ /^($eucpre(?:$ascii|$twoBytes|$threeBytes)$eucpost)(.*)/) {          # EUC1ʸѥޥå
		$char = $1;
		$tmpstr = $2;
	}

	return $char;
}

# 1ʸ᤹(٤)
sub back_char {
	my $tmp = shift;
	$tmpstr = $tmp . $tmpstr;
}

sub readstring {
	my $mode = shift;
	my $c;
	my $mystr;
	my $localstr = '';

	while(($c = get_char()) != -1){
		if($mode == -1){
			if($c eq ')'){
				back_char(')');
				last;
			}
		}
		if($c eq '{'){
			# 
			read_token();

			factor1();			# 

			if($now_token{tokType} ne '}'){
				print "}ĤƤޤ";		# ƥ
				exit;
			}
			pop_stack(\%t1);
			set_var(\%t1);

			if($t1{tokType} eq $TYPE_VALUE){
				$mystr = $t1{value};
			} else {
				$mystr = $t1{str};
				# աƥ塢{}ǤѿִhtmlΥ򥫥åȤޤΤᡢ
				# *S(0)="ۤ&";
				# *S(1)="{S(0)}"
				# ϡȤۤʤäΤˤʤޤ(S(1) "ۤ&amp;"ˤʤ)
				$mystr = bdUtil::sanitize($mystr);
			}
			$localstr = $localstr . $mystr;
		} elsif ($c eq "'"){
			$c = get_char();
			if($c eq "'"){
				$localstr = $localstr . "'";
			} elsif($c != -1){
				back_char($c);
				last;
			}
		} else {
			$localstr = $localstr . $c;
		}
	}

	return $localstr;
}

sub read_token {
	my $i,$j;
	my $localstr;
	my $flg;
	my $same;
	my $mulVal;
	my $c;
	my $val;


	# 򥫥å
	$tmpstr =~ s/^(?:\s|\t)+//o;

#	黻ҡ⤷ϡ()פĴ٤
	foreach $symb (@symbol_name) {
		if($tmpstr =~ /^\Q$symb\E(.*)/){
			$now_token{tokType} = $symb;
			$now_token{value} = 0;

			# $tmpstrʤ(Τʡ)
			$tmpstr = $1;

			return;
		}
	}

#	ѿޤϥफĴ٤
	if(($tmpstr =~ /^(F)(.*)/i) ||
	   ($tmpstr =~ /^(I)(.*)/i) ||
	   ($tmpstr =~ /^(S)(.*)/i) ||
	   ($tmpstr =~ /^(R)(.*)/i) ||
	   ($tmpstr =~ /^(X)(.*)/i)){
		$now_token{tokType} = $1;
		$now_token{value} = 0;		# ǥå

		$tmpstr = $2;

		return;
	}


#	ͤĴ٤
	if($tmpstr =~ /^[0-9]/){
		if($tmpstr =~ /^[0-9]x([0-9a-fA-F]+)(.*)/){		# 16ʿ
			$val = hex($1);
			$tmpstr = $2;
		} elsif ($tmpstr =~ /^([0-9]+)(.*)/){		# 10ʿ
			$val = $1;		# Τޤ޿͡
			$tmpstr = $2;
		}
		$now_token{tokType} = $TYPE_VALUE;
		$now_token{value} = $val;

		return;
	}
#	꤫Ĵ٤(ʤ)
	if($tmpstr eq ''){
		$now_token{tokType} = -1;
		$now_token{value} = 0;

		return;
	}


#	嵭ǤʤСʸȤƽ
	if(($tmpstr =~ /^'(.*)/)){
		$flg = 0;
		$tmpstr = $1;
	} else {
		$flg = -1;
	}


	my $str = readstring($flg);		# ʸɤ߹

	$now_token{tokType} = $TYPE_STRING;
	$now_token{str} = $str;

}

sub convert {
	my $line = shift;
	my $str;
	my $cnt = 0;

#	print "line:$line<br>";

	while(1){
		$str = $line;
		$tmpstr = $str;

		&read_token;
		factor1();

		# ͤ
		pop_stack(\%t1);
		%FLastVarToken = %t1;		# ѿŸΥȡ
		set_var(\%t1);

		if($t1{tokType} eq $TYPE_STRING){
			$str = $t1{str};
		} else {
			$str = $t1{value};
		}

		# ѿŸĤäƤʤäȴ(ƥȡʡ)
		if(!bdUtil::Match($str,'{')){
			last;
		}


	}

	%FLastToken = %t1;

	return $str;



	return $str;
}


1;




