# 
# bdKeyword.pm
# 
#   BLACK DIAMOND ɥ饹
#
# Copyright 2005 ONODA Production 
#
# $Id: bdKeyword.pm,v 1.1 2005/02/01 04:38:24 onoda Exp $

package bdKeyword;

# 󥹥ȥ饯
sub new{
	my $pkg = shift;

	bless {},$pkg;
}

# ɤؤɲ($kw)
# ʣɲäϤʤ
sub add {
	my $self  = shift;
	my $kw = shift;

	if(!grep(/^$kw$/,@{$self->{keyWords}})){
		push @{$self->{keyWords}}, $kw;
	}
}

# ɤμ(󻲾)
sub get_all {
	my $self  = shift;

	return $self->{keyWords};
}

# ɤԤĤƥȤˤƼ
sub get_text {
	my $self  = shift;
	my $strs;
	my $kw;

	$strs = "";
	foreach $kw (@{ $self->{keyWords} }){
		$kw = bdUtil::sanitize($kw);
		$strs .= $kw . "<br>\n";
	}

	return $strs;
}

# ɤΥꥢ
sub clear{
	my $self  = shift;

	$self->{keyWords} = ();
}

# ɤθĿ
sub count{
	my $self  = shift;

	return $#{ $self->{keyWords} } + 1;
}

# ʸ˥ꥢ饤(ɥ)
sub serialize{
	my $self  = shift;

	my $datas;
	my $cnt = $self->count();		# $#{ $self->{items} };

	$datas = "$cnt,";

	# CSV(֥륯Ȥޤϥޤޤ硢""Ǥ졢"""ˤʤ)
	# URL : http://www.din.or.jp/%7Eohzaki/perl.htm#CSVfromValues
	my @arr = @{ $self->{keyWords} };
	$datas .= join ',', map {(s/"/""/g or /[\r\n,]/) ? qq("$_") : $_} @arr;

	return $datas;
}


# ʸ󤫤ǥꥢ饤(ɥ)
sub deserialize{
	my $self  = shift;
	my $line  = shift;
	my $cnt;

	my @values = ();

	# ᤹
	# URL : http://www.din.or.jp/%7Eohzaki/perl.htm#CSV2Values
	{
		my $tmp = $line;
		$tmp =~ s/(?:\x0D\x0A|[\x0D\x0A])?$/,/;
		@values = map {/^"(.*)"$/ ? scalar($_ = $1, s/""/"/g, $_) : $_}
		($tmp =~ /("[^"]*(?:""[^"]*)*"|[^,]*),/g);
	}

	$cnt = shift @values;
	# ĿåƤ(ޤ̣ʤ)
	if($cnt != 0){
		@{$self->{keyWords}} = @values;
	} else {
		@{$self->{keyWords}} = ();
	}

}


# ǥȥ饯
sub DESTROY
{
    my $self = shift;
    undef @{$self->{keyWords}};
}


1;
